#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # 2A.ml - Classification binaire avec features textuelles
# 
# Ce notebook propose de voir comment incorporer des features pour voir l'amélioration des performances sur une classification binaire. 

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ## Récupérer les données
# 
# Les données sont téléchargeables [Compétition 2017 - additifs alimentaires](http://www.xavierdupre.fr/app/ensae_teaching_cs/helpsphinx/questions/competition_2A.html#id1) ou encore avec le code :

# In[2]:


from pyensae.datasource import download_data
data_train = download_data("off_train_all.zip", 
                           url="https://raw.githubusercontent.com/sdpython/data/master/OpenFoodFacts/")


# In[3]:


data_test = download_data("off_test_all.zip", 
                           url="https://raw.githubusercontent.com/sdpython/data/master/OpenFoodFacts/")


# In[4]:


import pandas
df = pandas.read_csv("off_test_all.txt", sep="\t", encoding="utf8", low_memory=False)


# In[5]:


df.head()


# In[6]:


df.head(n=2).T[:50]


# In[7]:


df.head(n=2).T[50:100]


# In[8]:


df.head(n=2).T[100:150]


# In[9]:


df.head(n=2).T[150:]


# ## Exercice 1 : extraire un échantillon aléatoire
# 
# Les données sont volumineuses. Prenons un échantillon pour aller plus vite.

# In[10]:





# ## Exercice 2 : caler un premier modèle de classification binaire
# 
# Avec les variables numériques uniquement. La cible est la variable ``hasE``.

# In[11]:





# ## Exercice 3 : tracer une courbe ROC

# In[12]:





# ## Exercice 4 : utiliser la variable qui contient le pays
# 
# Est-ce que le modèle est plus performant ?

# In[13]:





# ## Exercice 5 : utiliser la variable additives_tags ?
# 
# Les résultats ne vous paraissent-ils pas étranges ?

# In[14]:





# ## Exercice 6 : utiliser la variable ingredients_text ?
# 
# Que suggérez vous *embedding* ?

# In[15]:





# ## Exercice 7 : utiliser la variable product_name ?

# In[16]:





# ## Exercice 8 : utiliser GridSearch pour optimiser un hyper-paramètre du modèle ?

# In[17]:





# ## Exercice 9 : faites tourner une cross validation ?

# In[18]: